<?php

namespace Services;

use Zeedhi\Framework\Report\ReportService;

class MakeErrorReport
{
    const NAME_REPORT = "SUP00810";
    const STRATEGY_REPORT = "BIRT";

    public function __construct(ReportService $reportService)
    {
        $this->reportService = $reportService;
    }

    public function makeReportFile($order)
    {
        $parametersRow = [
            'P_CDFILDEST' => $order['cdFildest'],
            'P_TODASDT' => 'T',
            'P_TUSR_NRIMPORTAF' => null,
            'P_USR_NRIMPORTAF' => $order['numOrder'],
            'P_NRORG' => '1',
            'P_DTFIN' => null,
            'P_DTINI' => null
        ];
        $report = $this->reportService->createRemoteReport(self::STRATEGY_REPORT, self::NAME_REPORT, $parametersRow);
        return $report;
    }

}
