/* Sistemas Integrados TEKNISA
  Gerao CFC (RNF) em Tabelas (Para outros pases)

Nome: 5014_SDXTRGO_ATUALIZA_NF_CFC.SQL

@C:\Web_503\Xdb\Src\Cli\SDX\SQL\Chi\5014_SDXTRGO_ATUALIZA_NF_CFC

Descrio:
Rotina criada para que ao alterar uma nota fiscal j exportada para a tabela "USR_CFC",
a mesma seja enviada novamente no fechamento do dia.

Criao:
04/06/2009 - Fabrcio Marcelo da Silva
*/

CREATE OR REPLACE TRIGGER ATUALIZA_NF_CFC
AFTER INSERT OR UPDATE OR DELETE ON ITEMPRODUTO FOR EACH ROW
DECLARE
   V_CDFILIAL    VARCHAR2(04);

BEGIN
   V_CDFILIAL := NULL;

   IF INSERTING OR UPDATING THEN
      SELECT MAX(TEK_CDFILIAL)
        INTO V_CDFILIAL
        FROM USR_CFC
       WHERE TEK_CDFILIAL = :NEW.CDFILIAL
         AND TEK_NRLANCTONF = :NEW.NRLANCTONF
         AND CFC_DTIMP IS NULL;

      IF NOT V_CDFILIAL IS NULL THEN
         UPDATE NOTAFISCAL
            SET DTEXPRNF = NULL,
                NREXPRNF = NULL
          WHERE CDFILIAL = :NEW.CDFILIAL
            AND NRLANCTONF = :NEW.NRLANCTONF;
      END IF;
   END IF;
   IF DELETING THEN
      SELECT MAX(TEK_CDFILIAL)
        INTO V_CDFILIAL
        FROM USR_CFC
       WHERE TEK_CDFILIAL = :OLD.CDFILIAL
         AND TEK_NRLANCTONF = :OLD.NRLANCTONF
         AND CFC_DTIMP IS NULL;

      IF NOT V_CDFILIAL IS NULL THEN
         UPDATE NOTAFISCAL
            SET DTEXPRNF = NULL,
                NREXPRNF = NULL
          WHERE CDFILIAL = :OLD.CDFILIAL
            AND NRLANCTONF = :OLD.NRLANCTONF;
      END IF;
   END IF;
END;
/

/*  Nesta rotina sero excludas da tabela "USR_CFC" as notas fiscais que foram excludas no
sistema Teknisa aps a exportao para a tabela "USR_CFC" e que ainda no foram importadas
para o sistema SAP, campo "CFC_DTIMP" vazio.  */

CREATE OR REPLACE TRIGGER EXCLUSAO_NF_CFC
AFTER DELETE ON NOTAFISCAL FOR EACH ROW
BEGIN
   DELETE FROM USR_CFC
    WHERE TEK_CDFILIAL = :OLD.CDFILIAL
      AND TEK_NRLANCTONF = :OLD.NRLANCTONF
      AND CFC_DTIMP IS NULL;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXCLUSAO_NF_CFC','5.03.073'); END;
/

